package com.leromro.core.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.leromro.common.core.domain.R;
import com.leromro.core.domain.MainOrders;
import com.leromro.core.domain.dto.OrderRequestDTO;
import com.leromro.core.domain.dto.SettlementOrderApplyDTO;
import com.leromro.core.domain.dto.SettlementOrderDTO;
import com.leromro.core.domain.dto.SettlementOrderListDTO;
import com.leromro.core.domain.vo.*;

import java.util.List;

public interface IMainOrderService extends IService<MainOrders> {
    List<MainOrdersVO> selectByUserId(String[] orderStatus, Long userId);

    R<OrderPaymentVO> createOrders(OrderRequestDTO orderRequest) throws Exception;


    List<webMainOrderListVO> webMainOrderList(MainOrdersVO mainOrdersVO);

    void startService(Long secondOrderId);

    WebMainOrdersInfoVO selectWebMainOrderInfoVO(Long mainOrderId);

    //支付成功后，向平台资金流水中增加数据
    public void changePlatformFinance ( List<Long> seconderIdList,MainOrders orders);

    /**
     * 获取结算订单列表
     * @param settlementOrderListDTO
     * @return
     */
    List<SettlementOrderListVO> selectSettlementOrderList(SettlementOrderListDTO settlementOrderListDTO);

    /**
     * 修改订单区域公司结算状态
     * @param mainOrderIds
     * @param status
     */
    void updateAreaSettlementStatus(List<Long> mainOrderIds, Integer status);

    /**
     * 提交结算申请时修改订单区域公司结算信息
     * @param settlementOrderApplyDTO
     */
    void updateAreaSettlementInfo(SettlementOrderApplyDTO settlementOrderApplyDTO);

    /**
     * 提交结算申请时修改订单服务中心结算信息
     * @param settlementOrderApplyDTO
     */
    void updateServiceCentreSettlementInfo(SettlementOrderApplyDTO settlementOrderApplyDTO);

    /**
     * 修改订单服务中心结算状态
     * @param mainOrderIds
     * @param status
     */
    void updateServiceCentreSettlementStatus(List<Long> mainOrderIds, Integer status);

    /**
     * 区域公司订单抽成结算
     * @param settlementOrderDTO
     */
    void areaSettlement(SettlementOrderDTO settlementOrderDTO);

    /**
     * 服务中心订单抽成结算
     * @param settlementOrderDTO
     */
    void serviceCentreSettlement(SettlementOrderDTO settlementOrderDTO);
}
